from http import HTTPStatus
from typing import Any

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.get_contacts_domain_response_200 import GetContactsDomainResponse200
from ...models.get_contacts_domain_response_400 import GetContactsDomainResponse400
from ...models.get_contacts_domain_response_401 import GetContactsDomainResponse401
from ...models.get_contacts_domain_response_500 import GetContactsDomainResponse500
from ...types import UNSET, Response


def _get_kwargs(
    *,
    q: str,
) -> dict[str, Any]:

    params: dict[str, Any] = {}

    params["q"] = q

    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": "/contacts/_domain",
        "params": params,
    }

    return _kwargs


def _parse_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> (
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
    | None
):
    if response.status_code == 200:
        response_200 = GetContactsDomainResponse200.from_dict(response.json())

        return response_200

    if response.status_code == 400:
        response_400 = GetContactsDomainResponse400.from_dict(response.json())

        return response_400

    if response.status_code == 401:
        response_401 = GetContactsDomainResponse401.from_dict(response.json())

        return response_401

    if response.status_code == 500:
        response_500 = GetContactsDomainResponse500.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> Response[
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    *,
    client: AuthenticatedClient,
    q: str,
) -> Response[
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
]:
    """Search contacts by domain

     Find all contacts with email addresses from a specific domain by searching messages

    Args:
        q (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[GetContactsDomainResponse200 | GetContactsDomainResponse400 | GetContactsDomainResponse401 | GetContactsDomainResponse500]
    """

    kwargs = _get_kwargs(
        q=q,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    *,
    client: AuthenticatedClient,
    q: str,
) -> (
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
    | None
):
    """Search contacts by domain

     Find all contacts with email addresses from a specific domain by searching messages

    Args:
        q (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        GetContactsDomainResponse200 | GetContactsDomainResponse400 | GetContactsDomainResponse401 | GetContactsDomainResponse500
    """

    return sync_detailed(
        client=client,
        q=q,
    ).parsed


async def asyncio_detailed(
    *,
    client: AuthenticatedClient,
    q: str,
) -> Response[
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
]:
    """Search contacts by domain

     Find all contacts with email addresses from a specific domain by searching messages

    Args:
        q (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[GetContactsDomainResponse200 | GetContactsDomainResponse400 | GetContactsDomainResponse401 | GetContactsDomainResponse500]
    """

    kwargs = _get_kwargs(
        q=q,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    *,
    client: AuthenticatedClient,
    q: str,
) -> (
    GetContactsDomainResponse200
    | GetContactsDomainResponse400
    | GetContactsDomainResponse401
    | GetContactsDomainResponse500
    | None
):
    """Search contacts by domain

     Find all contacts with email addresses from a specific domain by searching messages

    Args:
        q (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        GetContactsDomainResponse200 | GetContactsDomainResponse400 | GetContactsDomainResponse401 | GetContactsDomainResponse500
    """

    return (
        await asyncio_detailed(
            client=client,
            q=q,
        )
    ).parsed
